;
; Defines for Dragon / Tandy CoCo specific routines.
;

MDragon32		equ	$00
MDragon64		equ $01
MDragonAlpha	equ	$02
MCoCo12			equ	$10
MCoCo3			equ	$11

MDragon			equ	$00
MCoCo			equ	$01

machine_type:	fcb	MDragon32
dragon_or_coco:	fcb	MDragon

random:			fcc	'JD'

osrdch:	
		jsr		[IndKeyInput]	; use indirect address, as same on Dragon and Tandy
		rts

osrnd:	pshs	b
		ldd		random,pcr		; get current seed
		pshs	d
		aslb
		rola					; D=2R
		addd	,s				; D=3R
		std		,s
		aslb
		rola					; D=2 * 3R
		pshs	b				; (s) = 2 * 256 * 3R
		aslb
		rola					; D=4 * 3R
		aslb
		rola					; D=8 * 3R
		addd	1,s				; D=9 * 3R
		std		1,s				; (s+1)=3 * 3 * 3R
		puls	a
		ldb		#41				; D=2*256*3R+41
		subd	,s++			; tidy stack
		std		random,pcr		; save random
		tfr		b,a				; low 8 bits in a
		puls	b,pc
		
		
;osrnd:
;		tst		dragon_or_coco	; is it a dragon or a coco ?
;		bne		osrnd_coco		; coco, exec it's routine
;		jsr		DBasRandom8		; call dragon routine	
;		bra		osrnd_got
;		
;osrnd_coco:
;		jsr		CBasRandom8		; call coco routine
;osrnd_got:
;		lda		BasRandomSeed+1	; get random byte
;		rts
;
oswaitsync:
		pshs	x
		ldx		SysTimeVal		; get current timer
oswait_loop:
		cmpx	SysTimeVal		; equal ?
		beq		oswait_loop
		puls	x,pc
		
;
; Detect machine type Dragon or CoCo.
;
		
detect_machine_type:
		lda		$ffff			; Get top byte of reset vector
		ldb		#MDragon64		; machine type
		cmpa	#$b4			
		bne		check_tandy

		lda     $BF9C			; Check for Dragon 64 signature bytes
        cmpa    #$36				
		beq		found_dragon	; yep it's a 64
		
		lda		#MDragon32		; nope it's a 32
		bra		found_dragon
		
check_tandy:		
		ldb		#MCoCo12
		cmpa	#$27			; CoCo 1 or 2 ?
		beq		found_coco
		
		ldb		#MCoCo3

found_coco:
		stb		machine_type	; set machine type
		ldb		#MCoCo
		stb		dragon_or_coco	; flag coco
		rts
		
found_dragon:
		stb		machine_type	; set machine type
		clr		dragon_or_coco	; flag dragon
		rts

key_colour		equ	$43			; 'C'
key_mono		equ	$4D			; 'D'


; Prompt the user and select a colour set
select_colourset:

select_colourset_loop:
		leax	colourset_prompt-1,pcr	; point at message
		tst		dragon_or_coco			; check machine ?
		bne		select_coco
		
		jsr		DTextOutString			; prompt user
		jsr		DTextWaitKeyCurs		; Wait for key with cursor
		
		cmpa	#key_colour				; check for valid keys
		beq		set_colour
		cmpa	#key_mono
		beq		set_mono
		
		lda		#$0d					; print a return
		jsr		DBasicScreenOut
		bra		select_colourset_loop

select_coco:		
		jsr		CTextOutString			; prompt user
		jsr		CTextWaitKeyCurs		; Wait for key with cursor
		
		cmpa	#key_colour				; check for valid keys
		beq		set_colour
		cmpa	#key_mono
		beq		set_mono
		
		lda		#$0d					; print a return
		jsr		CBasicScreenOut
		bra		select_colourset_loop
		

		
		
set_colour:
		lda		#colour_mode			; set colour mode
		sta		mono_or_colour
		rts
	
set_mono:
		lda		#mono_mode				; set mono mode
		sta		mono_or_colour
		rts

colourset_prompt:
		fcb		$0d
		fcc		'COLOUR OR MONO (C/M) ?'
		fcb		0